#include <iostream>
using namespace std;

string g[10005];
int main()
{
    int az,bz,oz,abz,n;
    int a=0,b=0,o=0,ab=0,x;
    string unosgrupe,izlaz="moguce";
    cin >>n;
    cin >> oz>>az>>bz>>abz;
    for(int i=0;i<n;i++){
        cin >> unosgrupe;
        cin >>x;
        if(unosgrupe=="O"){
            o=x;
            if(oz>=o){
            oz=oz-o;
            cout<<o<<0<<0<<0;
            }
            else{
                izlaz="nemoguce";
            }
        }
        if(unosgrupe=="A"){
            a=x;
            if(az>=a){
                az=az-a;
                cout<<0<<a<<0<<0;
            }
            else{
                if(az+oz>=a){
                    cout<<a-az<<az<<0<<0;
                    oz=oz-a+az;
                    az=0;
                }
                else{
                    izlaz="nemoguce";
                }
            }
        }
        if(unosgrupe=="B"){
            b=x;
            if(bz>=b){
                cout<<0<<0<<b<<0;
                bz=bz-b;
            }
            else{
                if(bz+oz>=b){
                    cout <<b-bz<<0<<bz<<0;
                    oz=oz-b+bz;
                    bz=0;
                }
                else{
                    izlaz="nemoguce";
                }
            }
        }
        if(unosgrupe=="AB"){
            izlaz="nemoguce";
        }
    }
    if(izlaz=="nemoguce"){
    }
    cerr <<izlaz;
    return 0;
}